imagePullPolicy: IfNotPresent
gitlabUrl: https://gitlab.com/

unregisterRunners: true

terminationGracePeriodSeconds: 3600

concurrent: {{ gitlab_runner_k8s_runner_concurrent_jobs }}

checkInterval: 3

logLevel: info

sessionServer:
  enabled: false

rbac:
    create: true

    rules: []
    clusterWideAccess: false

    podSecurityPolicy:
        enabled: false
        resourceNames:
        - gitlab-runner

metrics:
    enabled: true

service:
    enabled: true
    type: LoadBalancer
    annotations:
{% for key, value in gitlab_runner_k8s_service_annotations.items() %}
        {{ key }}: "{{ value }}"
{% endfor %}

runners:
    config: |
        [[runners]]
        environment = {{ gitlab_runner_k8s_env_variables | to_json }}
        pre_build_script = """
            echo "This is a pre-build script for SKA."
            echo "Project: ${CI_PROJECT_NAME}"
            echo "Cluster Domain: {{ gitlab_runner_k8s_cluster_domain }}"
{% if gitlab_runner_k8s_kubeconfig_name %}
            cp ${{ gitlab_runner_k8s_kubeconfig_name }} $KUBECONFIG
{% endif %}
{% if gitlab_runner_k8s_override_cluster_domain %}
            if [[ -n "${CLUSTER_DOMAIN}" ]]; then
                echo "'CLUSTER_DOMAIN' will be set to '{{ gitlab_runner_k8s_cluster_domain }}'"
            fi
            export CLUSTER_DOMAIN="{{ gitlab_runner_k8s_cluster_domain }}"
{% endif %}
        """
        [runners.kubernetes]
            name = "{{ gitlab_runner_k8s_runner_name }}"
            image = "ubuntu:22.04"
            helper_cpu_request = "{{ gitlab_runner_k8s_helper_cpu_request }}"
            helper_memory_request = "{{ gitlab_runner_k8s_helper_memory_request }}"
            service_cpu_request = "{{ gitlab_runner_k8s_service_cpu_request }}"
            service_memory_request = "{{ gitlab_runner_k8s_service_memory_request }}"
            cpu_request = "{{ gitlab_runner_k8s_cpu_request }}"
            memory_request = "{{ gitlab_runner_k8s_memory_request }}"
            cpu_request_overwrite_max_allowed = "{{ gitlab_runner_k8s_cpu_request_overwrite_max_allowed }}"
            memory_request_overwrite_max_allowed = "{{ gitlab_runner_k8s_memory_request_overwrite_max_allowed }}"
            cpu_limit = "{{ gitlab_runner_k8s_cpu_limit }}"
            memory_limit = "{{ gitlab_runner_k8s_memory_limit }}"
            helper_cpu_limit = "{{ gitlab_runner_k8s_helper_cpu_limit }}"
            helper_memory_limit = "{{ gitlab_runner_k8s_helper_memory_limit }}"
            service_cpu_limit = "{{ gitlab_runner_k8s_service_cpu_limit }}"
            service_memory_limit = "{{ gitlab_runner_k8s_service_memory_limit }}"
            poll_timeout = 600
            namespace = "{{ gitlab_runner_k8s_namespace }}"
{% if gitlab_runner_k8s_runtime_class_name | length > 0 %}
            runtime_class_name = "{{ gitlab_runner_k8s_runtime_class_name }}"
{% endif %}
            privileged = true
            pull_policy = ["always", "if-not-present"]
            pod_labels_overwrite_allowed = "{{ gitlab_runner_k8s_labels_basename }}.*"
            pod_annotations_overwrite_allowed = "{{ gitlab_runner_k8s_annotations_basename }}.*"
{% if gitlab_runner_k8s_dind_enabled and not gitlab_runner_k8s_dind_as_service %}
        [[runners.kubernetes.volumes.empty_dir]]
            name = "docker-certs"
            mount_path = "/certs/client"
            medium = "Memory"
        [[runners.kubernetes.services]]
            name = "docker:24.0.5-dind"
            alias = "docker"
{% endif %}
{% if gitlab_runner_k8s_node_selectors != [] %}
        [runners.kubernetes.node_selector]
{% for node_selector in gitlab_runner_k8s_node_selectors %}
            "{{ node_selector.key }}" = "{{ node_selector.value }}"
{% endfor %}
{% endif %}
{% if gitlab_runner_k8s_node_tolerations != [] %}
        [runners.kubernetes.node_tolerations]
{% for node_toleration in gitlab_runner_k8s_node_tolerations %}
            "{{ node_toleration.key }}={{ node_toleration.value }}" = "{{ node_toleration.effect }}"
{% endfor %}
{% endif %}
{% if gitlab_runner_k8s_use_cache %}
        [runners.cache]
            Type = "s3"
            Shared = true
            [runners.cache.s3]
                ServerAddress = "{{  gitlab_runner_k8s_s3_cache_address }}"
                BucketName = "{{  gitlab_runner_k8s_s3_bucket_name }}"
                BucketLocation = "{{  gitlab_runner_k8s_s3_bucket_location }}"
                Insecure = true
                AuthenticationType = "access-key"
{% endif %}

{% if not gitlab_runner_k8s_dind_enabled %}
        [runners.kubernetes.volumes]
            [[runners.kubernetes.volumes.host_path]]
            name = "docker"
            mount_path = "/var/run/docker.sock"
            host_path  = "/var/run/docker.sock"
{% endif %}

    secret: "{{ gitlab_runner_k8s_runner_name }}-registration-token"
{% if gitlab_runner_k8s_use_cache %}
    cache:
        secretName: "{{ gitlab_runner_k8s_runner_name }}-s3-access-credentials"
{% endif %}
    builds: {}
    services: {}
    helpers: {}
    runner-registration-token: ""
    runner-token: "{{ gitlab_runner_registration_token }}"
    
podSecurityContext:
    fsGroup: 65533
    runAsUser: 100

resources: {}
affinity: {}
nodeSelector: 
    {{ gitlab_runner_k8s_default_node_selector.key }}: '{{ gitlab_runner_k8s_default_node_selector.value }}'

tolerations: []
envVars:
- name: RUNNER_NAME
  value: "{{ gitlab_runner_k8s_runner_name }}"
{% if gitlab_runner_k8s_runner_env_vars is defined %}
{% for var in gitlab_runner_k8s_runner_env_vars %}
- name: {{ var.name }}
  value: {{ var.value }}
{% endfor %}
{% endif %}

hostAliases: []
podLabels: {}
configMaps: {}
